package controleur;

import java.time.LocalTime;

import domaine.Alarme;
import domaine.ListeDAlarmes;
import domaine.temps.Heure;
import vue.DialogueAlarme;
import vue.FenetreDAlarmes;

import javax.swing.*;
import javax.swing.filechooser.FileNameExtensionFilter;

public class Controleur extends Thread {
    private FenetreDAlarmes fenetre;
    private ListeDAlarmes alarmes;
    public Controleur() {
        fenetre = null;
        alarmes = null;
    }
    public void vue(FenetreDAlarmes f) {
        fenetre = f;
    }
    public void modele(ListeDAlarmes l) {
        alarmes = l;
    }
    public void charge() {
        JFileChooser fileChooser = new JFileChooser();
        FileNameExtensionFilter filter = new FileNameExtensionFilter("Fichiers d'alarmes", "alrm");
        fileChooser.setFileFilter(filter);
        fileChooser.setAcceptAllFileFilterUsed(false);
        switch (fileChooser.showOpenDialog(fenetre)) {
            case JFileChooser.CANCEL_OPTION  :
                break;
            case JFileChooser.APPROVE_OPTION :
                break;
            case JFileChooser.ERROR_OPTION   :
                JOptionPane.showMessageDialog(fenetre,
                        "Un problème est survenu lors du choix de fichier.\nLes alarmes n'ont pas été chargées.",
                        "Alarmes non chargées",
                        JOptionPane.ERROR_MESSAGE);
                break;
        }
    }
    public void enregistre() {
    }
    public void enregistreSous() {
        JFileChooser fileChooser = new JFileChooser();
        FileNameExtensionFilter filter = new FileNameExtensionFilter("Fichiers d'alarmes", "alrm");
        fileChooser.setFileFilter(filter);
        fileChooser.setAcceptAllFileFilterUsed(false);
        switch (fileChooser.showSaveDialog(fenetre)) {
            case JFileChooser.CANCEL_OPTION  :
                break;
            case JFileChooser.APPROVE_OPTION :
                break;
            case JFileChooser.ERROR_OPTION   :
                JOptionPane.showMessageDialog(fenetre,
                        "Un problème est survenu lors du choix de fichier.\nLes alarmes n'ont pas été enregistrées.",
                        "Alarmes non enregistrées",
                        JOptionPane.ERROR_MESSAGE);
                break;
        }
    }
    public void nouvelleAlarme() {
        try {
            Alarme alarme = new Alarme("12:00");
            ajouteAlarme(alarme);
        } catch(Exception e) { };
    }
    public void ajouteAlarme(Alarme alarme) {
        alarmes.ajoute(alarme);
        alarmes.trie();
        fenetre.metAJourLaListe();
        fenetre.desactiveEditeur();
        fenetre.metAJourLeTitre();
    }
    public void modifieAlarme(Alarme alarme, String heure) {
        try { alarme.heure().affecteA(heure); } catch(Exception e) { }
        alarmes.trie();
        fenetre.metAJourLaListe();
        fenetre.desactiveEditeur();
        fenetre.metAJourLeTitre();
    }
    public void supprimeAlarme(Alarme alarme) {
        alarmes.retire(alarme);
        fenetre.metAJourLaListe();
        fenetre.desactiveEditeur();
        fenetre.metAJourLeTitre();
    }
    public void run() {
        while (true) {
            LocalTime now = LocalTime.now();
            for (Alarme a : alarmes) {
                Heure h = a.heure();
                if (h.heures() == now.getHour() && h.minutes() == now.getMinute()) {
                    new DialogueAlarme().affiche(a);
                    break;
                }
            }
            try { sleep(60000); } catch (InterruptedException e) { }
        }
    }
}
