package vue;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;

import controleur.Controleur;

public class BarreDeMenus extends JMenuBar {
    private JMenuItem itemEnregistre;
    private Controleur ctrl;
    public BarreDeMenus(Controleur c)  {
        super();
        ctrl = c;
        JMenu menu;
        JMenuItem item;

        menu = new JMenu("Alarmes");
        add(menu);
        item = new JMenuItem("A propos...");
        item.addActionListener((ActionEvent e) -> new DialogueAPropos().affiche());
        menu.add(item);
        menu.addSeparator();
        item = new JMenuItem("Ouvrir...");
        item.addActionListener((ActionEvent e) -> ctrl.charge());
        menu.add(item);
        item = new JMenuItem("Enregistrer");
        item.setEnabled(false);
        itemEnregistre = item;
        item.addActionListener((ActionEvent e) -> ctrl.enregistre());
        menu.add(item);
        item = new JMenuItem("Enregistrer sous...");
        item.addActionListener((ActionEvent e) -> ctrl.enregistreSous());
        menu.add(item);
        menu.addSeparator();
        item = new JMenuItem("Quitter");
        item.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    System.exit(0);
                }
            }
        );
        menu.add(item);
        
        menu = new JMenu("Alarme");
        add(menu);
        item = new JMenuItem("Nouvelle");
        item.addActionListener((ActionEvent e) -> ctrl.nouvelleAlarme());
        menu.add(item);
    }
    public void activeOptionEnregistrer(boolean b) {
    	itemEnregistre.setEnabled(b);
    }
}
